## ros-dashing-kinesis-manager 2.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(kinesis_manager)
set(KINESIS_MANAGER_VERSION 0.1.0)

set(CMAKE_CXX_STANDARD 14)

find_package(aws_common REQUIRED)
if(AWSSDK_FOUND)
  set(SERVICE kinesis)
  AWSSDK_DETERMINE_LIBS_TO_LINK(SERVICE AWSSDK_LIBS_TO_LINK)
  link_directories("${AWSSDK_LIB_DIR}")
endif()

find_package(CURL REQUIRED)

## Add KVS SDK libraries
include(FindKVSSDK.cmake)
add_subdirectory(kvssdk)


#############
## Library ##
#############

## Declare a C++ library
add_library(${PROJECT_NAME} SHARED src/stream_definition_provider.cpp 
  src/kinesis_stream_manager.cpp src/default_callbacks.cpp
  src/kinesis_video_stream_interface.cpp src/kinesis_video_producer_interface.cpp)
set(${PROJECT_NAME}_IMPORTED_LIBRARIES producer)
add_dependencies(${PROJECT_NAME} KVS_SDK_IMPORT)

foreach(_imported_lib ${${PROJECT_NAME}_IMPORTED_LIBRARIES})
  if(NOT TARGET ${_imported_lib})
    add_library(${_imported_lib} UNKNOWN IMPORTED)
    set_target_properties(${_imported_lib} PROPERTIES
      INTERFACE_INCLUDE_DIRECTORIES "${AWSSDK_EXTERNAL_INCLUDE_DIR}")
    set_target_properties(${_imported_lib} PROPERTIES
      IMPORTED_LINK_INTERFACE_LANGUAGES "CXX"
      IMPORTED_LOCATION "${KVSSDK_EXTERNAL_LIB_DIR}/lib${_imported_lib}.so")
    set_property(TARGET producer APPEND PROPERTY
      IMPORTED_CONFIGURATIONS RELEASE)
  endif()
endforeach()

target_include_directories(${PROJECT_NAME} PRIVATE ${aws_common_INCLUDE_DIRS} ${AWSSDK_INCLUDE_DIR} ${KVSSDK_EXTERNAL_INCLUDE_DIR})
target_include_directories(${PROJECT_NAME} PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>)
target_link_libraries(${PROJECT_NAME} ${AWSSDK_LIBS_TO_LINK} ${${PROJECT_NAME}_IMPORTED_LIBRARIES} log4cplus)


#############
## Tests ##
#############

enable_testing()

# Build tests which perform API calls to AWS and require user configuration set up
if(BUILD_AWS_TESTING)
  add_definitions(-DBUILD_AWS_TESTING)
endif()

find_common_test_packages()

add_common_gtest(test_kinesis_manager
  test/kinesis_manager_test.cpp
)
target_include_directories(test_kinesis_manager PRIVATE
  ${aws_common_INCLUDE_DIRS}
  ${KVSSDK_EXTERNAL_INCLUDE_DIR}
)
target_link_libraries(test_kinesis_manager
  ${PROJECT_NAME}
  ${aws_common_LIBRARIES}
  ${GMOCK_LIBRARY}
  pthread
)

add_common_gtest(test_stream_subscription_installer
  test/stream_subscription_installer_test.cpp
)
target_include_directories(test_stream_subscription_installer PRIVATE
  ${aws_common_INCLUDE_DIRS}
  ${KVSSDK_EXTERNAL_INCLUDE_DIR}
)
target_link_libraries(test_stream_subscription_installer
  ${PROJECT_NAME}
  ${GMOCK_LIBRARY}
  pthread
)

add_common_gtest(test_default_callbacks
  test/default_callbacks_test.cpp
)
target_include_directories(test_default_callbacks PRIVATE
  ${aws_common_INCLUDE_DIRS}
  ${KVSSDK_EXTERNAL_INCLUDE_DIR}
)
target_link_libraries(test_default_callbacks
  ${PROJECT_NAME}
  ${aws_common_LIBRARIES}
  ${GMOCK_LIBRARY}
  pthread
)


#############
## Install ##
#############

## Mark executables and/or libraries for installation
install(TARGETS ${PROJECT_NAME}
  EXPORT "${PROJECT_NAME}-targets"
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

## Mark cpp header files for installation
install(
  DIRECTORY include/
  DESTINATION include
)

## Export KVS SDK artifacts
install(
  DIRECTORY ${KVSSDK_EXTERNAL_LIB_DIR}/
  DESTINATION lib/
)

install(
  DIRECTORY ${KVSSDK_EXTERNAL_INCLUDE_DIR}/
  DESTINATION include
)

export(TARGETS ${PROJECT_NAME}
  FILE "${PROJECT_BINARY_DIR}/${PROJECT_NAME}-targets.cmake")
export(PACKAGE ${PROJECT_NAME})

CONFIGURE_FILE(${PROJECT_NAME}Config.cmake.in
  ${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake @ONLY)
CONFIGURE_FILE(${PROJECT_NAME}ConfigVersion.cmake.in
  ${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake @ONLY)

INSTALL(FILES ${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake DESTINATION share/${PROJECT_NAME}/cmake)
INSTALL(FILES ${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake DESTINATION share/${PROJECT_NAME}/cmake)
INSTALL(EXPORT ${PROJECT_NAME}-targets DESTINATION share/${PROJECT_NAME}/cmake)
INSTALL(FILES FindKVSSDK.cmake DESTINATION share/${PROJECT_NAME}/cmake)

=== kvssdk/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(KVSSDK)
set(KVSSDK_VERSION 1.7.8)
set(KVSSDK_MD5 9f3da8e64603198fe20d5c38e4a4cb08)

if(NOT EXTERNAL_INSTALL_LOCATION)
  set(EXTERNAL_INSTALL_LOCATION ${CMAKE_BINARY_DIR}/external)
endif()

#############
## Library ##
#############
file(MAKE_DIRECTORY ${EXTERNAL_INSTALL_LOCATION}/include)
file(MAKE_DIRECTORY ${EXTERNAL_INSTALL_LOCATION}/lib)

include(ExternalProject)
ExternalProject_Add(KVS_SDK_IMPORT
  SOURCE_DIR ${EXTERNAL_INSTALL_LOCATION}/src
  URL https://github.com/awslabs/amazon-kinesis-video-streams-producer-sdk-cpp/archive/${KVSSDK_VERSION}.tar.gz
  URL_MD5 ${KVSSDK_MD5}
  BINARY_DIR ${EXTERNAL_INSTALL_LOCATION}/src/kinesis-video-native-build
  PATCH_COMMAND cp ${CMAKE_CURRENT_SOURCE_DIR}/apply-kvs-patch ${CMAKE_CURRENT_SOURCE_DIR}/install-kvs ${EXTERNAL_INSTALL_LOCATION}
      && chmod +x ${EXTERNAL_INSTALL_LOCATION}/apply-kvs-patch ${EXTERNAL_INSTALL_LOCATION}/install-kvs
      && ${EXTERNAL_INSTALL_LOCATION}/apply-kvs-patch ${EXTERNAL_INSTALL_LOCATION}/src/kinesis-video-native-build
  CONFIGURE_COMMAND ""
  BUILD_COMMAND ${EXTERNAL_INSTALL_LOCATION}/src/kinesis-video-native-build/min-install-script
  INSTALL_COMMAND ${EXTERNAL_INSTALL_LOCATION}/install-kvs ${EXTERNAL_INSTALL_LOCATION}
)

#############
## Install ##
#############
install(
  DIRECTORY ${EXTERNAL_INSTALL_LOCATION}/lib/
  DESTINATION lib/
)

install(
  DIRECTORY ${EXTERNAL_INSTALL_LOCATION}/include/
  DESTINATION include
)

## Mark executables and/or libraries for installation
export(PACKAGE ${PROJECT_NAME})

=== debian/changelog ===
ros-dashing-kinesis-manager (2.0.1-1bionic) bionic; urgency=high

  * Merge pull request #32 <https://github.com/aws-robotics/kinesisvideo-common/issues/32> from aws-robotics/bump-version-2-0-1
    Bump version
  * Bump version
    md5 sum was changed. Bumping version in preparation for release.
  * Update md5 checksum for KVS SDK (#27 <https://github.com/aws-robotics/kinesisvideo-common/issues/27>)
  * Use standard CMake macros for adding gtest/gmock tests (#24 <https://github.com/aws-robotics/kinesisvideo-common/issues/24>)
    * use the macro in aws_common to find test dependencies for ROS1 or ROS2
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * update travis.yml to be compatible with specifying multiple package names
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * update travis.yml test matrix
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * update PACKAGE_NAMES
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
  * update kvs producer sdk to v1.7.8
  * Improve unit tests coverage
    * Add KinesisVideoProducerInterface and
    KinesisVideoStreamInterface in order to use
    mocks for Kinesis Video Streams
    * Resulting in the following overall coverage rate:
    ```
    lines......: 88.8% (906 of 1020 lines)
    functions..: 86.0% (208 of 242 functions)
    branches...: 38.0% (1346 of 3544 branches)
    ```
  * Update to use non-legacy ParameterReader API (#12 <https://github.com/aws-robotics/kinesisvideo-common/issues/12>)
  * Update to use new ParameterReader API (#11 <https://github.com/aws-robotics/kinesisvideo-common/issues/11>)
    * clean up CMakeFiles
    * Adjusting usage of the ParameterReader due to the updated API taking in a ParameterPath.
    * refactor based on new ParameterPath object design
    * increment major version number in package.xml
  * Merge pull request #5 <https://github.com/aws-robotics/kinesisvideo-common/issues/5> from mm318/master
    Executable permission for script files
  * fix permission issues when this repo is zipped
  * Contributors: Juan Rodriguez Hortala, M. M, Miaofei, Ross Desmond, Tim Robinson

 -- AWS RoboMaker <ros-contributions@amazon.com>  Fri, 26 Jul 2019 07:00:00 -0000

=== debian/control ===
Source: ros-dashing-kinesis-manager
Section: misc
Priority: extra
Maintainer: AWS RoboMaker <ros-contributions@amazon.com>
Build-Depends: debhelper (>= 9.0.0), cmake, curl, libboost-all-dev, libcurl4-openssl-dev, liblog4cplus-dev, libssl-dev, pkg-config, ros-dashing-ament-cmake-gmock, ros-dashing-ament-cmake-gtest, ros-dashing-aws-common, ros-dashing-ros-workspace
Homepage: http://wiki.ros.org/kinesis_manager
Standards-Version: 3.9.2

Package: ros-dashing-kinesis-manager
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, curl, libboost-all-dev, libcurl4-openssl-dev, liblog4cplus-dev, libssl-dev, ros-dashing-aws-common, ros-dashing-ros-workspace
Description: AWS Kinesis stream management library intended for use with the Kinesis Video Producer SDK

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/dashing/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX="/opt/ros/dashing"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-dashing-kinesis-manager//opt/ros/dashing/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_install
